<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="3.0">
    <xsl:output method="adaptive"/>
    <xsl:param name="book"
        select="
            map {
                'book': map {
                    'title': 'Data on the Web',
                    'year': 2000,
                    'author': array {
                        map {
                            'last': 'Abiteboul',
                            'first': 'Serge'
                        },
                        map {
                            'last': 'Buneman',
                            'first': 'Peter'
                        },
                        map {
                            'last': 'Suciu',
                            'first': 'Dan'
                        }
                    },
                    'publisher': 'Morgan Kaufmann Publishers',
                    'price': 39.95
                }
            }"/>

    <xsl:template name="main">
        <!-- Array -->
        <!-- evaluates to 5 -->
        <xsl:value-of select="[ [1, 2, 3], [4, 5, 6]](2)(2)"/>
        <!-- evaluates to 123 -->
        <xsl:value-of select="array { 'licorice', 'ginger' ,'a', 123, 'Robert Johnson'}(4)"/>

        <!-- Map -->
        <!-- returns the string Data on the Web -->
        <xsl:value-of select="$book('book')('title')"/>
        <!-- returns the last name of the first author-->
        <xsl:value-of select="$book('book')('author')(1)('last')"/>

        <!-- Lookup operator -->
        <!--  evaluates to "Jenna" -->
        <xsl:value-of
            select="
                map {
                    'first': 'Jenna',
                    'last': 'Scott'
                }?first"/>
        <!-- evaluates to 6 -->
        <xsl:value-of select="[4, 5, 6]?3"/>
        <!--  evaluates to the sequence ("Tom", "Dick", "Harry") -->
        <xsl:variable name="names" select="(map {'first': 'Tom'}, map {'first': 'Dick'}, map {'first': 'Harry'})?first"/>
        <xsl:value-of select="$names"/>

        <!-- Simple map operator (!) -->
        <!-- Outputs the strings by prepending "id-" -->
        <xsl:value-of select="$names ! concat('id-', .)"/>
    </xsl:template>
</xsl:stylesheet>
